// CREDIT: by zoidberg
// ISADORA_VEC4_COLOR_PARAM(slideAmt, whs2, 0x00000000, "No help available.")
// ISADORA_INT_PARAM_ONOFF(reflection, SXNS, 0, "No help available.")


uniform sampler2D tex0;
uniform vec4 slideAmt;
uniform bool reflection;

void main() {
	vec4		srcPixel = texture2D(tex0, gl_TexCoord[0].xy);
	if (reflection == true)	{
		vec4		outPixel;
		outPixel.rgb = srcPixel.rgb - slideAmt.rgb;
		outPixel.a = srcPixel.a + slideAmt.a;	//	alpha behaves the same in both modes (just easier to work with)
		gl_FragColor.x = (outPixel.x<0.0) ? outPixel.x+1.0 : outPixel.x;
		gl_FragColor.y = (outPixel.y<0.0) ? outPixel.y+1.0 : outPixel.y;
		gl_FragColor.z = (outPixel.z<0.0) ? outPixel.z+1.0 : outPixel.z;
		//gl_FragColor.a = (outPixel.a<0.0) ? outPixel.a+1.0 : outPixel.a;
		gl_FragColor.a = (outPixel.a>1.0) ? outPixel.a-1.0 : outPixel.a;
	}
	else	{
		vec4		outPixel = srcPixel+slideAmt;
		gl_FragColor.x = (outPixel.x>1.0) ? outPixel.x-1.0 : outPixel.x;
		gl_FragColor.y = (outPixel.y>1.0) ? outPixel.y-1.0 : outPixel.y;
		gl_FragColor.z = (outPixel.z>1.0) ? outPixel.z-1.0 : outPixel.z;
		gl_FragColor.a = (outPixel.a>1.0) ? outPixel.a-1.0 : outPixel.a;
	}
}
