// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(width, ^c-[, -1000000, +1000000, 0.25, "No help available.")
// ISADORA_FLOAT_PARAM(offset_x, r5~+, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(offset_y, x[{~, 0, 1, 0, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color1, Yc>j, 0xFFFFFFFF, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color2, CrWY, 0xFF000000, "No help available.")
// ISADORA_FLOAT_PARAM(splitPos_x, k?tQ, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(splitPos_y, cs+1, 0, 1, 0.5, "No help available.")

#define offset vec2(offset_x,offset_y)
#define splitPos vec2(splitPos_x,splitPos_y)

uniform float width;
uniform float offset_x;
uniform float offset_y;
uniform vec4 color1;
uniform vec4 color2;
uniform float splitPos_x;
uniform float splitPos_y;
uniform vec2 resolution;



void main() {
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	//	determine if we are on an even or odd line
	//	math goes like..
	//	mod(((coord+offset) / width),2)
	
	
	vec4		out_color = color2;
	float		size = width * resolution.x;

	if (size == 0.0)	{
		out_color = color1;
	}
	else if ((mod(((gl_FragCoord.x+(offset.x*resolution.x)) / size),2.0) < 2.0 * splitPos.x)&&(mod(((gl_FragCoord.y+(offset.y*resolution.y)) / size),2.0) > 2.0 * splitPos.y))	{
		out_color = color1;
	}
	else if ((mod(((gl_FragCoord.x+(offset.x*resolution.x)) / size),2.0) > 2.0 * splitPos.x)&&(mod(((gl_FragCoord.y+(offset.y*resolution.y)) / size),2.0) < 2.0 * splitPos.y))	{
		out_color = color1;
	}
	
	gl_FragColor = out_color;
}
