// CREDIT: by zoidberg
// ISADORA_FLOAT_PARAM(levels, $vWD, 2, 30, 30, "No help available.")


uniform sampler2D tex0;
uniform float levels;

void main() {
	//	get the src pixel, convert to HSL, posterize the 'L', convert back to RGB
	vec4		srcPixel = texture2D(tex0, gl_TexCoord[0].xy);
	vec4		amountPerLevel = vec4(1.0/levels);
	vec4		numOfLevels = floor(srcPixel/amountPerLevel);
	vec4		outColor = numOfLevels * (vec4(1.0) / (vec4(levels) - vec4(1.0)));
	outColor.a = srcPixel.a;
	gl_FragColor = outColor;
}
