// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(mix_amount, Ha&[, 0, 1, 0.5, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float mix_amount;
uniform vec2 resolution;

void main() {
	vec4 thisColor = texture2D(tex0, gl_TexCoord[0].xy);
	vec2 lookupCoord;
	lookupCoord.x = mix (thisColor.r, thisColor.g, mix_amount);
	lookupCoord.x = mix (lookupCoord.x, thisColor.b, mix_amount);
	lookupCoord.x = resolution.x * lookupCoord.x / 255.0;
	
	lookupCoord.y = mix (thisColor.r, thisColor.g, mix_amount);
	lookupCoord.y = mix (lookupCoord.y, thisColor.b, mix_amount);
	lookupCoord.y = resolution.y * lookupCoord.y / 255.0;
	
	gl_FragColor = texture2D(tex1, lookupCoord);
}
