// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/fade.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// author: gre
// license: MIT

vec4 transition (vec2 uv) {
  return mix(
    getFromColor(uv),
    getToColor(uv),
    progress
  );
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
