// CREDIT: by zoidberg
// ISADORA_VEC4_COLOR_PARAM(brightColor, >CB?, 0xFFFFE5CC, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(darkColor, r=k&, 0xFF4C0000, "No help available.")


uniform sampler2D tex0;
uniform vec4 brightColor;
uniform vec4 darkColor;

//const vec4		lumcoeff = vec4(0.299, 0.587, 0.114, 0.0);
const vec4 	lumcoeff = vec4(0.2126, 0.7152, 0.0722, 0.0);

void main() {
	vec4		srcPixel = texture2D(tex0, gl_TexCoord[0].xy);
	float		luminance = dot(srcPixel,lumcoeff);
	gl_FragColor = mix(vec4(darkColor.rgb, srcPixel.a), vec4(brightColor.rgb, srcPixel.a), luminance);
}
