// CREDIT: by VIDVOX
// ISADORA_PLUGIN_DESC("Draws an RGB histogram from a provided histogram image")


uniform sampler2D tex0;


void main()	{
	vec4        outColor = vec4(0., 0., 0., 0.);
	vec4        histoVals = texture2D(tex0, vec2(gl_TexCoord[0].xy.x, 0.5));
	if (histoVals.r >= gl_TexCoord[0].xy.y)	{
		outColor.r = 1.0;
		outColor.a = 1.0;
	}
	if (histoVals.g >= gl_TexCoord[0].xy.y)	{
		outColor.g = 1.0;
		outColor.a = 1.0;
	}
	if (histoVals.b >= gl_TexCoord[0].xy.y)	{
		outColor.b = 1.0;
		outColor.a = 1.0;
	}
	
	gl_FragColor = outColor;
	
}
