// CREDIT: by Carter Rosenberg
// ISADORA_INT_PARAM_ONOFF(horizontal, 2WA4, 1, "No help available.")
// ISADORA_INT_PARAM_ONOFF(vertical, |1G=, 0, "No help available.")


uniform sampler2D tex0;
uniform bool horizontal;
uniform bool vertical;
uniform vec2 resolution;

void main()
{
	vec2 pixelCoord = gl_TexCoord[0].xy * resolution;
	vec2 loc = pixelCoord;
	if (vertical)	{
		if (mod(pixelCoord.x,2.0)>1.0)	{
			loc.y = resolution.y - pixelCoord.y;
		}
	}
	if (horizontal)	{
		if (mod(pixelCoord.y,2.0)>1.0)	{
			loc.x = resolution.x - pixelCoord.x;
		}	
	}
	gl_FragColor = texture2D(tex0, (loc)/resolution);
}
