// ISADORA_FLOAT_PARAM(offset_x, r5~+, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(offset_y, x[{~, 0, 1, 0.5, "No help available.")
// ISADORA_INT_PARAM_ONOFF(repeatImage, \A<<, 0, "No help available.")

#define offset vec2(offset_x,offset_y)

uniform sampler2D tex0;
uniform float offset_x;
uniform float offset_y;
uniform bool repeatImage;
uniform vec2 resolution;

void main()	{
	vec4		outputColor = vec4(0.0);
	vec2		newLoc = offset;
	vec2		topSize = resolution;
	
	newLoc = offset * resolution;
	newLoc.x = topSize.x - newLoc.x;
	newLoc.y = topSize.y - newLoc.y;
	newLoc = (gl_FragCoord.xy + 2.0*newLoc) - topSize;
	
	if (repeatImage)	{
		newLoc = mod(newLoc, resolution);	
	}
	
	if ((newLoc.x >= 0.0)&&(newLoc.x < resolution.x)&&(newLoc.y >= 0.0)&&(newLoc.y <= resolution.y))	{
		outputColor = texture2D(tex0, (newLoc)/resolution);
	}
	
	gl_FragColor = outputColor;
}
