// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/luma.glsl
// ISADORA_PLUGIN_DESC("Automatically converted from https://gl-transitions.com/")
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform sampler2D tex2;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: gre
// License: MIT


vec4 transition(vec2 uv) {
  return mix(
    getToColor(uv),
    getFromColor(uv),
    step(progress, texture2D(tex2, uv).r-0.001)
  );
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
