// CREDIT: by VIDVOX
// ISADORA_INT_PARAM_ONOFF(horizontal, 2WA4, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(vertical, |1G=, 0, "No help available.")


uniform sampler2D tex0;
uniform bool horizontal;
uniform bool vertical;

void main() {
	//	gl_TexCoord[0].xy[0] and gl_TexCoord[0].xy[1] are my normalized x/y coordinates
	//	if we're not doing a flip in either direction we can just pass thru
	vec2		normSrcCoord;

	normSrcCoord.x = gl_TexCoord[0].xy[0];
	normSrcCoord.y = gl_TexCoord[0].xy[1];

	if ((normSrcCoord.x > 0.5)&&(horizontal))	{
		normSrcCoord.x = (1.0-normSrcCoord.x);
	}
	if ((normSrcCoord.y > 0.5)&&(vertical))	{
		normSrcCoord.y = (1.0-normSrcCoord.y);
	}
	
	gl_FragColor = texture2D(tex0, normSrcCoord);
}
