// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(level, M*EO, 0.01, 10, 1, "No help available.")
// ISADORA_FLOAT_PARAM(center_x, tvT}, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(center_y, }%&g, 0, 1, 0, "No help available.")

#define center vec2(center_x,center_y)

uniform sampler2D tex0;
uniform float level;
uniform float center_x;
uniform float center_y;

void main() {
	vec2		loc;
	vec2		modifiedCenter;
	
	loc = gl_TexCoord[0].xy;
	modifiedCenter = center;
	loc.x = (loc.x - modifiedCenter.x)*(1.0/level) + modifiedCenter.x;
	loc.y = (loc.y - modifiedCenter.y)*(1.0/level) + modifiedCenter.y;
	if ((loc.x < 0.0)||(loc.y < 0.0)||(loc.x > 1.0)||(loc.y > 1.0))	{
		gl_FragColor = vec4(0.0);
	}
	else	{
		gl_FragColor = texture2D(tex0, loc);
	}
}
