// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/burn.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color, }%NT, 0xFFFFFFFF, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform vec4 color;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// author: gre
// License: MIT
vec4 transition (vec2 uv) {
  return mix(
    getFromColor(uv) + progress*color,
    getToColor(uv) + (1.0-progress)*color,
    progress
  );
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
