// CREDIT: by zoidberg
// ISADORA_FLOAT_PARAM(intensity, d5~/, 0, 1, 1, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color, }%NT, 0xFF99724C, "No help available.")


uniform sampler2D tex0;
uniform float intensity;
uniform vec4 color;


//const vec4		lumcoeff = vec4(0.299, 0.587, 0.114, 0.0);
const vec4 	lumcoeff = vec4(0.2126, 0.7152, 0.0722, 0.0);

void main() {
	vec4		srcPixel = texture2D(tex0, gl_TexCoord[0].xy);
	float		luminance = dot(srcPixel,lumcoeff);
	//float		luminance = (srcPixel.r + srcPixel.g + srcPixel.b)/3.0;
	vec4		dstPixel = (luminance >= 0.50)
		? mix(color, vec4(1,1,1,srcPixel.a), (luminance-0.5)*2.0)
		: mix(vec4(0,0,0,srcPixel.a), color, luminance*2.0);
	gl_FragColor = mix(srcPixel, dstPixel, intensity);
}
