// CREDIT: by carter rosenberg
// ISADORA_FLOAT_PARAM(inputEV, <^7s, -10, 10, 0.5, "No help available.")


uniform sampler2D tex0;
uniform float inputEV;



void main() {
	//	based on
	//	https://developer.apple.com/library/mac/documentation/graphicsimaging/reference/CoreImageFilterReference/Reference/reference.html#//apple_ref/doc/filter/ci/CIExposureAdjust
	vec4		tmpColorA = texture2D(tex0, gl_TexCoord[0].xy);
	tmpColorA.rgb = tmpColorA.rgb * pow(2.0, inputEV);
	gl_FragColor = tmpColorA;
}
