// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/fadecolor.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(colorPhase, }h+K, 0, 1, 0.25, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color, }%NT, 0xFF000000, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float colorPhase;
uniform vec4 color;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// author: gre
// License: MIT
vec4 transition (vec2 uv) {
  return mix(
    mix(color, getFromColor(uv), smoothstep(1.0-colorPhase, 0.0, progress)),
    mix(color, getToColor(uv), smoothstep(    colorPhase, 1.0, progress)),
    progress);
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
