// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(size, ~5ox, 0, 1, 0.25, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color, }%NT, 0xFFFF0000, "No help available.")


uniform float size;
uniform vec4 color;
uniform vec2 resolution;


//	Adapted from https://glsl.io/transition/d71472a550601b96d69d

 
bool inHeart (vec2 p, vec2 center, float size) {
	if (size == 0.0) return false;
	vec2 o = (p-center)/(1.6*size);
	return pow(o.x*o.x+o.y*o.y-0.3, 3.0) < o.x*o.x*pow(o.y, 3.0);
}
 
void main() {
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	vec2 p = isf_FragNormCoord;
	float m = inHeart(p, vec2(0.5, 0.4), size) ? 1.0 : 0.0;
	gl_FragColor = mix(vec4(0.0), color, m);
}
