// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/PolkaDotsCurtain.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(dots, D?mP, 0, 100, 20, "No help available.")
// ISADORA_FLOAT_PARAM(center_x, tvT}, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(center_y, }%&g, 0, 1, 0, "No help available.")

#define center vec2(center_x,center_y)

uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float dots;
uniform float center_x;
uniform float center_y;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// author: bobylito
// license: MIT
const float SQRT_2 = 1.414213562373;

vec4 transition(vec2 uv) {
  bool nextImage = distance(fract(uv * dots), vec2(0.5, 0.5)) < ( progress / distance(uv, center));
  return nextImage ? getToColor(uv) : getFromColor(uv);
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
