// CREDIT: VIDVOX
// ISADORA_PLUGIN_DESC("Posterizes an image")
// ISADORA_FLOAT_PARAM(gamma, ]Z6S, 0.5, 2, 1.25, "No help available.")
// ISADORA_FLOAT_PARAM(numColors, BpHx, 3, 32, 6, "No help available.")


uniform sampler2D tex0;
uniform float gamma;
uniform float numColors;

void main()	{
	
    vec4	c = texture2D(tex0, gl_TexCoord[0].xy);

 	c.rgb = pow(c.rgb, vec3(gamma, gamma, gamma));
 	c.rgb = c.rgb * numColors;
 	c.rgb = floor(c.rgb);
 	c.rgb = c.rgb / numColors;
 	c.rgb = pow(c.rgb, vec3(1.0/gamma));

	gl_FragColor = c;
}
