// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(red, WP-~, 0, 2, 1, "No help available.")
// ISADORA_FLOAT_PARAM(green, giHS, 0, 2, 1, "No help available.")
// ISADORA_FLOAT_PARAM(blue, ju{n, 0, 2, 1, "No help available.")
// ISADORA_FLOAT_PARAM(gain, laoL, -1, 1, 0, "No help available.")


uniform sampler2D tex0;
uniform float red;
uniform float green;
uniform float blue;
uniform float gain;




void main() {
	vec4	pixel = texture2D(tex0, gl_TexCoord[0].xy);	
	float	brightness = (pixel.r * red + pixel.g * green + pixel.b * blue) / 3.0;
	
	pixel.r = pixel.r * red;
	pixel.g = pixel.g * green;
	pixel.b = pixel.b * blue;

	if (gain >= 0.0)	{
		pixel.a = (brightness >= gain) ? pixel.a : 0.0;
	}
	else	{
		pixel.a = (brightness <= 1.0-abs(gain)) ? pixel.a : 0.0;
	}
	gl_FragColor = pixel;
}
