// CREDIT: by VIDVOX
// ISADORA_INT_PARAM(redInput, gdui, 0, 4, 0, "No help available.")
// ISADORA_INT_PARAM(greenInput, =}2N, 0, 4, 1, "No help available.")
// ISADORA_INT_PARAM(blueInput, Gf=+, 0, 4, 2, "No help available.")
// ISADORA_INT_PARAM(alphaInput, jn}W, 0, 4, 3, "No help available.")


uniform sampler2D tex0;
uniform int redInput;
uniform int greenInput;
uniform int blueInput;
uniform int alphaInput;

void main() {
	vec4		srcPixel = texture2D(tex0, gl_TexCoord[0].xy);
	vec4		outputPixel = srcPixel;
	float		avgVal = (srcPixel.r + srcPixel.g + srcPixel.b) * srcPixel.a / 3.0;
	
	if (redInput == 0)	{
		outputPixel.r = srcPixel.r;
	}
	else if (redInput == 1)	{
		outputPixel.r = srcPixel.g;
	}
	else if (redInput == 2)	{
		outputPixel.r = srcPixel.b;
	}
	else if (redInput == 3)	{
		outputPixel.r = srcPixel.a;
	}
	else if (redInput == 4)	{
		outputPixel.r = avgVal;
	}
	
	if (greenInput == 0)	{
		outputPixel.g = srcPixel.r;
	}
	else if (greenInput == 1)	{
		outputPixel.g = srcPixel.g;
	}
	else if (greenInput == 2)	{
		outputPixel.g = srcPixel.b;
	}
	else if (greenInput == 3)	{
		outputPixel.g = srcPixel.a;
	}
	else if (greenInput == 4)	{
		outputPixel.g = avgVal;
	}
	
	if (blueInput == 0)	{
		outputPixel.b = srcPixel.r;
	}
	else if (blueInput == 1)	{
		outputPixel.b = srcPixel.g;
	}
	else if (blueInput == 2)	{
		outputPixel.b = srcPixel.b;
	}
	else if (blueInput == 3)	{
		outputPixel.b = srcPixel.a;
	}
	else if (blueInput == 4)	{
		outputPixel.b = avgVal;
	}
	
	
	if (alphaInput == 0)	{
		outputPixel.a = srcPixel.r;
	}
	else if (alphaInput == 1)	{
		outputPixel.a = srcPixel.g;
	}
	else if (alphaInput == 2)	{
		outputPixel.a = srcPixel.b;
	}
	else if (alphaInput == 3)	{
		outputPixel.a = srcPixel.a;
	}
	else if (alphaInput == 4)	{
		outputPixel.a = avgVal;
	}
	
	gl_FragColor = outputPixel;
}
