// CREDIT: BrianChasalow
// ISADORA_FLOAT_PARAM(slide, X_-i, 0, 2, 0, "No help available.")
// ISADORA_FLOAT_PARAM(shift, S#J0, 0, 2, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(mirrorHorizontal, EXng, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(mirrorVertical, 5ak_, 0, "No help available.")


uniform sampler2D tex0;
uniform float slide;
uniform float shift;
uniform bool mirrorHorizontal;
uniform bool mirrorVertical;

void main(void)
{
	vec2 retard = gl_TexCoord[0].xy;
	retard.x += slide;
	retard.y += shift;
	vec2 moddedRetard = mod(retard,1.0);
	
	if(mirrorHorizontal && retard.x >= 1.0 && retard.x <= 2.0)
		moddedRetard = vec2(1.0-moddedRetard.x, moddedRetard.y);
	if(mirrorVertical && retard.y >= 1.0 && retard.y <= 2.0)
		moddedRetard = vec2(moddedRetard.x, 1.0-moddedRetard.y);
	
	vec4 pixel = texture2D(tex0, moddedRetard);
	gl_FragColor = pixel;
}
