// CREDIT: VIDVOX
// ISADORA_FLOAT_PARAM(width, ^c-[, -1000000, +1000000, 0.25, "No help available.")
// ISADORA_FLOAT_PARAM(offset, 7>D/, -1000000, +1000000, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(vertical, |1G=, 0, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color1, Yc>j, 0xFFFFFFFF, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color2, CrWY, 0xFF000000, "No help available.")
// ISADORA_FLOAT_PARAM(splitPos, 3uCQ, 0, 1, 0.5, "No help available.")


uniform float width;
uniform float offset;
uniform bool vertical;
uniform vec4 color1;
uniform vec4 color2;
uniform float splitPos;
uniform vec2 resolution;



void main() {
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	//	determine if we are on an even or odd line
	//	math goes like..
	//	mod(((coord+offset) / width),2)
	
	
	vec4 out_color = color2;
	float coord = isf_FragNormCoord[0];

	if (vertical)	{
		coord = isf_FragNormCoord[1];
	}
	if (width == 0.0)	{
		out_color = color1;
	}
	else if(mod(((coord+offset) / width),2.0) < 2.0 * splitPos)	{
		out_color = color1;
	}
	
	gl_FragColor = out_color;
}
